コメントコンポーネントのコメントのリンクをコピーする機能について解説します。
リンクのコピー
デフォルトでは、コメントコンポーネントのコメント情報にリンクのコピーを制御するアイコンが表示されます。また、この機能は実行環境がHTTPかHTTPSかによって動作が異なります。
HTTP環境では、セキュリティ制限のため基本的にリンク形式のみコピー可能です。クリップボードに<a href="formatted_link">formatted_link</a>のようなHTMLAnchorElement(アンカー要素)が保存されます。この場合、表示されるテキストをカスタマイズすることができません。
HTTPS環境では、Clipboard APIを使用して、リッチテキスト形式(HTML)とプレーンテキスト形式の両方をクリップボードに保存できます。この場合、リンクに表示されるテキストやURLの構成などを設定できます。
リンクに表示されるテキスト
copiedLinkDisplayTextFormatterコールバックを使用して、HTTPS環境でコピーしたコメントを貼り付ける場合にリンクに表示されるテキストを設定できます。戻り値のlinkTextでコメントのリンクとして表示されるテキスト、infoTextで補足のテキストを設定できます。
設定例は以下の通りです。
リンクを開く方法
openLinkModeプロパティを利用して、コピーしたリンクの開き方を設定することができます。openLinkModeプロパティには、OpenLinkMode列挙体の次の値を引数として設定することができます。
OpenLinkModeの値
説明
NewTab
新しいタブでリンクを開く
CurrentTab
現在のタブでリンクを開く
GoToComment
コメントまでスクロールする
import './styles.css';
import '@mescius/inputman.comment/CSS/gc.inputman.comment.css';
import '@mescius/inputman.richtexteditor/CSS/gc.inputman.richtexteditor.css';
import { InputMan } from '@mescius/inputman.comment';
import * as RichTextEditorControl from '@mescius/inputman.richtexteditor';
import { postedComments } from './data';
const gcComment = new InputMan.GcComment(document.getElementById('gcComment'), {
openLinkMode: InputMan.OpenLinkMode.GoToComment,
editorConfig: {
editorType: InputMan.GcCommentEditorType.GcRichTextEditor,
height: 150,
menubar: [],
},
userInfo: {
id: '1',
name: '森上 偉久馬',
avatar: '$IMDEMOROOT$/ja/samples/comment/copylink/overview/img/avatar1.png',
},
loadComments: (args) => {
return {
comments: postedComments,
};
},
copiedLinkDisplayTextFormatter: (comment) => {
return {
linkText: `${comment.userInfo.name}: ${comment.content}`,
infoText: `${comment.postTime.toLocaleString('ja-JP', { dateStyle: 'long', timeStyle: 'short' })} に送信`
};
}
});
<!DOCTYPE html>
<html>
<head>
<meta charset="UTF-8">
<meta name="viewport" content="width=device-width, initial-scale=1.0">
<meta http-equiv="X-UA-Compatible" content="ie=edge">
<meta name="description" content="コメントコンポーネント 使い方" lang="ja" xml:lang="ja" />
<title>コメントコンポーネント - リンクのコピー</title>
<!-- SystemJS -->
<script src="node_modules/systemjs/dist/system.src.js"></script>
<script src="systemjs.config.js"></script>
<script>
window.onload = function () {
System.import('./src/app');
}
</script>
</head>
<body>
<div id="gcComment"></div>
</body>
</html>
body {
box-sizing: content-box !important;
height: 551px !important;
}
export const postedComments = [
{
id: '1',
userInfo: {
id: '1',
name: '森上 偉久馬',
avatar: '$IMDEMOROOT$/ja/samples/comment/copylink/overview/img/avatar1.png',
},
content: `<b>このサンプルでは、コメントをコピーする際の動作を確認することができます。</b>
<p>コメント情報に表示されるコピーアイコンからコメントをコピーし、コメントエディタにペーストしてみてください。</p>`,
postTime: new Date(2024, 1, 1, 8, 0, 0),
updateTime: new Date(2024, 1, 1, 8, 0, 0),
reactions: [
{
reactionChar: '👍',
count: 1,
},
],
},
{
id: '2',
userInfo: {
id: '2',
name: '葛城 孝史',
avatar: '$IMDEMOROOT$/ja/samples/comment/copylink/overview/img/avatar2.png',
},
content: '特定のコメントを他のメンバーと共有したい場合に利用されます。共有されたリンクを開くと、対象のコメントに移動し、スムーズに内容を確認できます。',
postTime: new Date(2024, 7, 23, 8, 1, 59),
updateTime: new Date(2024, 7, 23, 8, 1, 59),
reactions: [
{
reactionChar: '👍',
count: 6,
currentUserReacted: true,
},
],
},
{
id: '3',
userInfo: {
id: '4',
name: '川村 匡',
avatar: '$IMDEMOROOT$/ja/samples/comment/copylink/overview/img/avatar4.png',
},
content: '貼り付ける際に表示されるリンクのテキストと補足テキストをカスタマイズしました。',
postTime: new Date(2024, 7, 23, 8, 5, 6),
updateTime: new Date(2024, 7, 23, 8, 5, 6),
reactions: [
{
reactionChar: '👍',
count: 6,
currentUserReacted: true,
},
],
}
];
System.config({
transpiler: 'plugin-babel',
babelOptions: {
es2015: true
},
meta: {
'*.css': { loader: 'css' }
},
paths: {
// paths serve as alias
'npm:': 'node_modules/'
},
// map tells the System loader where to look for things
map: {
'@mescius/inputman': 'npm:@mescius/inputman/index.js',
'@mescius/inputman/CSS': 'npm:@mescius/inputman/CSS',
'@mescius/inputman.richtexteditor': 'npm:@mescius/inputman.richtexteditor/index.js',
"@mescius/inputman.richtexteditor/CSS": "npm:@mescius/inputman.richtexteditor/CSS",
'@mescius/inputman.richtexteditor/JS/plugins/advlist': 'npm:@mescius/inputman.richtexteditor/JS/plugins/advlist/plugin.js',
'@mescius/inputman.richtexteditor/JS/plugins/all': 'npm:@mescius/inputman.richtexteditor/JS/plugins/all/plugin.js',
'@mescius/inputman.richtexteditor/JS/plugins/autosave': 'npm:@mescius/inputman.richtexteditor/JS/plugins/autosave/plugin.js',
'@mescius/inputman.richtexteditor/JS/plugins/charmap': 'npm:@mescius/inputman.richtexteditor/JS/plugins/charmap/plugin.js',
'@mescius/inputman.richtexteditor/JS/plugins/directionality': 'npm:@mescius/inputman.richtexteditor/JS/plugins/directionality/plugin.js',
'@mescius/inputman.richtexteditor/JS/plugins/emoticons': 'npm:@mescius/inputman.richtexteditor/JS/plugins/emoticons/plugin.js',
'@mescius/inputman.richtexteditor/JS/plugins/fullscreen': 'npm:@mescius/inputman.richtexteditor/JS/plugins/fullscreen/plugin.js',
'@mescius/inputman.richtexteditor/JS/plugins/htmlcode': 'npm:@mescius/inputman.richtexteditor/JS/plugins/htmlcode/plugin.js',
'@mescius/inputman.richtexteditor/JS/plugins/image': 'npm:@mescius/inputman.richtexteditor/JS/plugins/image/plugin.js',
'@mescius/inputman.richtexteditor/JS/plugins/link': 'npm:@mescius/inputman.richtexteditor/JS/plugins/link/plugin.js',
'@mescius/inputman.richtexteditor/JS/plugins/lists': 'npm:@mescius/inputman.richtexteditor/JS/plugins/lists/plugin.js',
'@mescius/inputman.richtexteditor/JS/plugins/media': 'npm:@mescius/inputman.richtexteditor/JS/plugins/media/plugin.js',
'@mescius/inputman.richtexteditor/JS/plugins/pagebreak': 'npm:@mescius/inputman.richtexteditor/JS/plugins/pagebreak/plugin.js',
'@mescius/inputman.richtexteditor/JS/plugins/preview': 'npm:@mescius/inputman.richtexteditor/JS/plugins/preview/plugin.js',
'@mescius/inputman.richtexteditor/JS/plugins/save': 'npm:@mescius/inputman.richtexteditor/JS/plugins/save/plugin.js',
'@mescius/inputman.richtexteditor/JS/plugins/searchreplace': 'npm:@mescius/inputman.richtexteditor/JS/plugins/searchreplace/plugin.js',
'@mescius/inputman.richtexteditor/JS/plugins/table': 'npm:@mescius/inputman.richtexteditor/JS/plugins/table/plugin.js',
'@mescius/inputman.richtexteditor/JS/plugins/template': 'npm:@mescius/inputman.richtexteditor/JS/plugins/template/plugin.js',
'@mescius/inputman.richtexteditor/JS/plugins/wordcount': 'npm:@mescius/inputman.richtexteditor/JS/plugins/wordcount/plugin.js',
'@mescius/inputman.comment': 'npm:@mescius/inputman.comment/index.js',
'@mescius/inputman.comment/CSS': 'npm:@mescius/inputman.comment/CSS',
'@mescius/wijmo': 'npm:@mescius/wijmo/index.js',
'@mescius/wijmo.styles': 'npm:@mescius/wijmo.styles',
'@mescius/wijmo.cultures': 'npm:@mescius/wijmo.cultures',
'@mescius/wijmo.input': 'npm:@mescius/wijmo.input/index.js',
'@mescius/wijmo.grid': 'npm:@mescius/wijmo.grid/index.js',
'@mescius/wijmo.nav': 'npm:@mescius/wijmo.nav/index.js',
'@mescius/spread-sheets': 'npm:@mescius/spread-sheets/index.js',
'@mescius/spread-sheets-resources-ja': 'npm:@mescius/spread-sheets-resources-ja/index.js',
'@mescius/spread-sheets/styles': 'npm:@mescius/spread-sheets/styles',
'css': 'npm:systemjs-plugin-css/css.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
'systemjs-babel-build': 'npm:systemjs-plugin-babel/systemjs-babel-browser.js'
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
src: {
defaultExtension: 'js'
},
"node_modules": {
defaultExtension: 'js'
},
}
});

コメントコンポーネントのコメントのリンクをコピーする機能について解説します。
リンクのコピー
デフォルトでは、コメントコンポーネントのコメント情報にリンクのコピーを制御するアイコンが表示されます。また、この機能は実行環境がHTTPかHTTPSかによって動作が異なります。
HTTP環境では、セキュリティ制限のため基本的にリンク形式のみコピー可能です。クリップボードに<a href="formatted_link">formatted_link</a>のようなHTMLAnchorElement(アンカー要素)が保存されます。この場合、表示されるテキストをカスタマイズすることができません。
HTTPS環境では、Clipboard APIを使用して、リッチテキスト形式(HTML)とプレーンテキスト形式の両方をクリップボードに保存できます。この場合、リンクに表示されるテキストやURLの構成などを設定できます。
リンクに表示されるテキスト
copiedLinkDisplayTextFormatterコールバックを使用して、HTTPS環境でコピーしたコメントを貼り付ける場合にリンクに表示されるテキストを設定できます。戻り値のlinkTextでコメントのリンクとして表示されるテキスト、infoTextで補足のテキストを設定できます。
設定例は以下の通りです。
リンクを開く方法
openLinkModeプロパティを利用して、コピーしたリンクの開き方を設定することができます。openLinkModeプロパティには、OpenLinkMode列挙体の次の値を引数として設定することができます。
OpenLinkModeの値
説明
NewTab
新しいタブでリンクを開く
CurrentTab
現在のタブでリンクを開く
GoToComment
コメントまでスクロールする
<template>
<GcCommentComponent
:openLinkMode="openLinkMode"
:editorConfig="editorConfig"
:userInfo="userInfo"
:loadComments="loadComments"
:copiedLinkDisplayTextFormatter="copiedLinkDisplayTextFormatter"
/>
</template>
<script setup>
import './styles.css';
import '@mescius/inputman.comment/CSS/gc.inputman.comment.css';
import '@mescius/inputman.richtexteditor/CSS/gc.inputman.richtexteditor.css';
import { GcCommentComponent } from '@mescius/inputman.comment.vue';
import { postedComments } from './data.js';
import * as GCCommentControl from '@mescius/inputman.comment';
import '@mescius/inputman.richtexteditor';
const openLinkMode = GCCommentControl.InputMan.OpenLinkMode.GoToComment;
const editorConfig = {
editorType: GCCommentControl.InputMan.GcCommentEditorType.GcRichTextEditor,
height: 150,
menubar: [],
};
const userInfo = {
id: '1',
name: '森上 偉久馬',
avatar: '$IMDEMOROOT$/ja/samples/comment/copylink/overview/img/avatar1.png',
};
const loadComments = (args) => {
return {
comments: postedComments,
};
};
const copiedLinkDisplayTextFormatter = (comment) => {
return {
linkText: `${comment.userInfo.name}: ${comment.content}`,
infoText: `${comment.postTime.toLocaleString('ja-JP', { dateStyle: 'long', timeStyle: 'short' })} に送信`
};
}
</script>
<style src="./styles.css"></style>
<!doctype html>
<html lang="en">
<head>
<meta charset="utf-8">
<meta http-equiv="X-UA-Compatible" content="IE=edge">
<meta name="description" content="" lang="ja" xml:lang="ja" />
<title>コメントコンポーネント - リンクのコピー</title>
<meta name="viewport" content="width=device-width, initial-scale=1.0">
<script src="node_modules/systemjs/dist/system.src.js"></script>
<script src="systemjs.config.js"></script>
<script src="compiler.js" type="module"></script>
<script>
window.onload = function() {
var System = SystemJS;
System.import("./src/app.js");
}
</script>
</head>
<body>
<div id="app"></div>
</body>
</html>
export const postedComments = [
{
id: '1',
userInfo: {
id: '1',
name: '森上 偉久馬',
avatar: '$IMDEMOROOT$/ja/samples/comment/copylink/overview/img/avatar1.png',
},
content: `<b>このサンプルでは、コメントをコピーする際の動作を確認することができます。</b>
<p>コメント情報に表示されるコピーアイコンからコメントをコピーし、コメントエディタにペーストしてみてください。</p>`,
postTime: new Date(2024, 1, 1, 8, 0, 0),
updateTime: new Date(2024, 1, 1, 8, 0, 0),
reactions: [
{
reactionChar: '👍',
count: 1,
},
],
},
{
id: '2',
userInfo: {
id: '2',
name: '葛城 孝史',
avatar: '$IMDEMOROOT$/ja/samples/comment/copylink/overview/img/avatar2.png',
},
content: '特定のコメントを他のメンバーと共有したい場合に利用されます。共有されたリンクを開くと、対象のコメントに移動し、スムーズに内容を確認できます。',
postTime: new Date(2024, 7, 23, 8, 1, 59),
updateTime: new Date(2024, 7, 23, 8, 1, 59),
reactions: [
{
reactionChar: '👍',
count: 6,
currentUserReacted: true,
},
],
},
{
id: '3',
userInfo: {
id: '4',
name: '川村 匡',
avatar: '$IMDEMOROOT$/ja/samples/comment/copylink/overview/img/avatar4.png',
},
content: '貼り付ける際に表示されるリンクのテキストと補足テキストをカスタマイズしました。',
postTime: new Date(2024, 7, 23, 8, 5, 6),
updateTime: new Date(2024, 7, 23, 8, 5, 6),
reactions: [
{
reactionChar: '👍',
count: 6,
currentUserReacted: true,
},
],
}
];
body {
box-sizing: content-box !important;
height: 551px !important;
}
(function (global) {
SystemJS.config({
transpiler: 'plugin-babel',
babelOptions: {
es2015: true
},
paths: {
// paths serve as alias
'npm:': 'node_modules/'
},
packageConfigPaths: [
'./node_modules/*/package.json',
"./node_modules/@mescius/*/package.json",
"./node_modules/@babel/*/package.json",
"./node_modules/@vue/*/package.json"
],
map: {
'vue': "npm:vue/dist/vue.esm-browser.js",
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
"systemjs-babel-build": "npm:systemjs-plugin-babel/systemjs-babel-browser.js",
"@mescius/inputman": 'npm:@mescius/inputman/index.js',
"@mescius/inputman.vue": 'npm:@mescius/inputman.vue/lib/gc.inputman.plugin.vue.js',
"@mescius/inputman/CSS": "npm:@mescius/inputman/CSS",
"@mescius/inputman.richtexteditor": "npm:@mescius/inputman.richtexteditor/index.js",
"@mescius/inputman.richtexteditor.vue": "npm:/@mescius/inputman.richtexteditor.vue/lib/gc.inputman.richtexteditor.plugin.vue.js",
"@mescius/inputman.richtexteditor/CSS": "npm:@mescius/inputman.richtexteditor/CSS",
'@mescius/inputman.richtexteditor/JS/plugins/advlist': 'npm:@mescius/inputman.richtexteditor/JS/plugins/advlist/plugin.js',
'@mescius/inputman.richtexteditor/JS/plugins/all': 'npm:@mescius/inputman.richtexteditor/JS/plugins/all/plugin.js',
'@mescius/inputman.richtexteditor/JS/plugins/autosave': 'npm:@mescius/inputman.richtexteditor/JS/plugins/autosave/plugin.js',
'@mescius/inputman.richtexteditor/JS/plugins/charmap': 'npm:@mescius/inputman.richtexteditor/JS/plugins/charmap/plugin.js',
'@mescius/inputman.richtexteditor/JS/plugins/directionality': 'npm:@mescius/inputman.richtexteditor/JS/plugins/directionality/plugin.js',
'@mescius/inputman.richtexteditor/JS/plugins/emoticons': 'npm:@mescius/inputman.richtexteditor/JS/plugins/emoticons/plugin.js',
'@mescius/inputman.richtexteditor/JS/plugins/fullscreen': 'npm:@mescius/inputman.richtexteditor/JS/plugins/fullscreen/plugin.js',
'@mescius/inputman.richtexteditor/JS/plugins/htmlcode': 'npm:@mescius/inputman.richtexteditor/JS/plugins/htmlcode/plugin.js',
'@mescius/inputman.richtexteditor/JS/plugins/image': 'npm:@mescius/inputman.richtexteditor/JS/plugins/image/plugin.js',
'@mescius/inputman.richtexteditor/JS/plugins/link': 'npm:@mescius/inputman.richtexteditor/JS/plugins/link/plugin.js',
'@mescius/inputman.richtexteditor/JS/plugins/lists': 'npm:@mescius/inputman.richtexteditor/JS/plugins/lists/plugin.js',
'@mescius/inputman.richtexteditor/JS/plugins/media': 'npm:@mescius/inputman.richtexteditor/JS/plugins/media/plugin.js',
'@mescius/inputman.richtexteditor/JS/plugins/pagebreak': 'npm:@mescius/inputman.richtexteditor/JS/plugins/pagebreak/plugin.js',
'@mescius/inputman.richtexteditor/JS/plugins/preview': 'npm:@mescius/inputman.richtexteditor/JS/plugins/preview/plugin.js',
'@mescius/inputman.richtexteditor/JS/plugins/save': 'npm:@mescius/inputman.richtexteditor/JS/plugins/save/plugin.js',
'@mescius/inputman.richtexteditor/JS/plugins/searchreplace': 'npm:@mescius/inputman.richtexteditor/JS/plugins/searchreplace/plugin.js',
'@mescius/inputman.richtexteditor/JS/plugins/table': 'npm:@mescius/inputman.richtexteditor/JS/plugins/table/plugin.js',
'@mescius/inputman.richtexteditor/JS/plugins/template': 'npm:@mescius/inputman.richtexteditor/JS/plugins/template/plugin.js',
'@mescius/inputman.richtexteditor/JS/plugins/wordcount': 'npm:@mescius/inputman.richtexteditor/JS/plugins/wordcount/plugin.js',
"@mescius/inputman.comment": 'npm:@mescius/inputman.comment/index.js',
"@mescius/inputman.comment.vue": 'npm:@mescius/inputman.comment.vue/lib/gc.inputman.comment.plugin.vue.js',
"@mescius/inputman.comment/CSS": "npm:@mescius/inputman.comment/CSS",
'@mescius/wijmo': 'npm:@mescius/wijmo/index.js',
'@mescius/wijmo.styles': 'npm:@mescius/wijmo.styles',
'@mescius/wijmo.cultures': 'npm:@mescius/wijmo.cultures/wijmo.culture.ja.js',
'@mescius/wijmo.nav': 'npm:@mescius/wijmo.nav/index.js',
'@mescius/wijmo.input': 'npm:@mescius/wijmo.input/index.js',
'@mescius/wijmo.grid': 'npm:@mescius/wijmo.grid/index.js',
'@mescius/spread-sheets': 'npm:@mescius/spread-sheets/index.js',
'@mescius/spread-sheets-resources-ja': 'npm:@mescius/spread-sheets-resources-ja/index.js',
'@mescius/spread-sheets/styles': 'npm:@mescius/spread-sheets/styles',
'css': 'npm:systemjs-plugin-css/css.js',
},
meta: {
'*.css': { loader: 'css' },
'*.vue': { loader: "../plugin-vue/index.js" }
}
});
})(this);